/**
 * 
 */
package net.java.amateras.uml.sequence.editpart;

import java.beans.PropertyChangeEvent;

import net.java.amateras.uml.figure.EntityFigure;
import net.java.amateras.uml.sequence.figure.SyncMessageConnectionFigure;
import net.java.amateras.uml.sequence.model.MessageModel;
import net.java.amateras.uml.sequence.model.SyncMessageModel;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.gef.EditPolicy;

/**
 * @author Takahiro Shida.
 *
 */
public class SyncMessageEditPart extends MessageEditPart {

	protected IFigure createFigure() {
		SyncMessageModel model = (SyncMessageModel) getModel();
		SyncMessageConnectionFigure figure = new SyncMessageConnectionFigure();
		figure.build(model.isRecursive());
		figure.getLabel().setText(model.getOrder() + "." + model.getName());
		return figure;
	}
	
	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new MessageComponentEditPolicy());
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		EntityFigure figure = (EntityFigure) getFigure();
		Label label = figure.getLabel();
		if (evt.getPropertyName().equals(MessageModel.P_NAME)) {
			SyncMessageModel model = (SyncMessageModel) getModel();
			label.setText(model.getOrder() + "." + model.getName());
		}
		if (evt.getPropertyName().equals(SyncMessageModel.P_ORDER)) {
			SyncMessageModel model = (SyncMessageModel) getModel();
			label.setText(model.getOrder() + "." + model.getName());
		}
	}
}
