/**
 * 
 */
package net.java.amateras.uml.sequence.figure;

import net.java.amateras.uml.UMLPlugin;
import net.java.amateras.uml.figure.EntityFigure;
import net.java.amateras.uml.figure.OperationLabel;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.CompoundBorder;
import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.swt.graphics.Color;

/**
 * @author Takahiro Shida.
 *
 */
public class InstanceFigure extends Figure implements EntityFigure {

	public static final Color INSTANCE_COLOR = new Color(null, 255, 255, 206);

	private OperationLabel name = null;
	
	public InstanceFigure() {
		super();
	}

	public InstanceFigure build() {
		this.name = new OperationLabel();
		this.name.setIcon(UMLPlugin.getImageDescriptor("icons/class.gif").createImage());
		this.name.setUnderline(true);
		ToolbarLayout layout = new ToolbarLayout();
		setLayoutManager(layout);
		setBorder(new CompoundBorder(new LineBorder(ColorConstants.black, 1), new MarginBorder(2)));
		setBackgroundColor(INSTANCE_COLOR);
		setOpaque(true);
		
		add(this.name);
		return this;
	}
	
	protected void setName(OperationLabel name) {
		this.name = name;
	}
	
	public void setInstanceName(String instanceName) {
		this.name.setText(instanceName);
	}

	public Label getLabel() {
		return this.name;
	}
}
